
------------------------------- Sample user tables ------------------------------- 
DROP TABLE customer;

CREATE TABLE customer 
(
	pkey		VARCHAR(10) NOT NULL	PRIMARY KEY,
	fname		VARCHAR(20),
	lname		VARCHAR(20),
	ccode		VARCHAR(10)
);

CREATE UNIQUE INDEX pkey_id 
ON customer(pkey) 
USING STOGROUP JDDBSTO 
PRIQTY 5 
SECQTY 5 
BUFFERPOOL BP0; 


DROP TABLE address;

CREATE TABLE address 
(
	addrid		VARCHAR(10) NOT NULL	PRIMARY KEY,
	custid		VARCHAR(10),
	city		VARCHAR(20),
	zipcode		VARCHAR(10),
	FOREIGN KEY(custid) REFERENCES customer(pkey)
);


CREATE UNIQUE INDEX addr_id 
ON address(addrid) 
USING STOGROUP JDDBSTO 
PRIQTY 5 
SECQTY 5 
BUFFERPOOL BP0; 


DROP TABLE custinfo;

CREATE TABLE custinfo 
(
	ccode		VARCHAR(10) NOT NULL	PRIMARY KEY,
	cdata		VARCHAR(10)
);


CREATE UNIQUE INDEX ccode_id 
ON custinfo(ccode) 
USING STOGROUP JDDBSTO 
PRIQTY 5 
SECQTY 5 
BUFFERPOOL BP0; 

COMMIT;

------------------------------------- Event table -------------------------------------

DROP TABLE wbia_jdbc_eventstore;

CREATE TABLE WBIA_JDBC_EventStore 
(
	event_id			INTEGER NOT NULL	GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1, NO CACHE )		PRIMARY KEY,
	xid				VARCHAR(200),
	object_key			VARCHAR(80)		NOT NULL,
	object_name			VARCHAR(40)		NOT NULL,
	object_function			VARCHAR(40)		NOT NULL,
	event_priority    		INTEGER			NOT NULL,
	event_time			TIMESTAMP		NOT NULL WITH DEFAULT,
	event_status			INTEGER			NOT NULL,
	connector_ID                    VARCHAR(40),
	event_comment			VARCHAR(100)
);

CREATE UNIQUE INDEX JEV_ID 
ON WBIA_JDBC_EventStore(event_id) 
USING STOGROUP JDDBSTO 
PRIQTY 5 
SECQTY 5 
BUFFERPOOL BP0; 

COMMIT; 


------------------------------------- Triggers for customer table -------------------------------------

DROP TRIGGER EVENT_CREATE;
DROP TRIGGER EVENT_UPDATE;
DROP TRIGGER EVENT_DELETE;


CREATE TRIGGER event_create 
AFTER INSERT ON CUSTOMER REFERENCING NEW AS N  
FOR EACH ROW MODE DB2SQL 
INSERT INTO wbia_jdbc_eventstore (object_key, object_name, object_function, event_priority, event_status,connector_ID)
VALUES (N.pkey, 'Db2adminCustomerBG', 'Create', 1, 0,'001');


CREATE TRIGGER event_udpate 
AFTER UPDATE ON CUSTOMER REFERENCING NEW AS N  
FOR EACH ROW MODE DB2SQL 
INSERT INTO wbia_jdbc_eventstore (object_key, object_name, object_function, event_priority, event_status,connector_ID)
VALUES (N.pkey, 'Db2adminCustomerBG', 'Update', 1, 0,'001');


CREATE TRIGGER event_delete 
AFTER DELETE ON CUSTOMER REFERENCING OLD AS O
FOR EACH ROW MODE DB2SQL 
INSERT INTO wbia_jdbc_eventstore (object_key, object_name, object_function, event_priority, event_status,connector_ID)
VALUES (O.pkey, 'Db2adminCustomerBG', 'Delete', 1, 0,'001');

